$! This script is a web interface to the VMS SET PASSWORD and 
$! PMDF PASSWORD commands. It creates a remote command shell using
$! RSH running under the username and old password submitted by the user
$! which then runs the SYS$MANAGER:SET_PASSWORD procedure to change
$! the user's password. Depending on the value of WWW_HTTP_REFERER (i.e.
$! the page that called this script) this script can also activate the user's
$! account by performing "@SYS$SYSTEM:SYSMGR_SERVER.COM NT_ACTIVATE"
$!
$! Assumptions:
$!	HTTP_SERVER is the username of the web server
$!
$! Author: C. A. Karcher Date:   22-OCT-1998
$! Modified:
$!	000420 - Rewritten to handle account activation
$!
$! Copyright 1998, C. A. Karcher
$! Waisman Center, University of Wisconsin-Madison
$!
$!
$! If we're not running under the web server, dispatch to user context
$
$ If F$Edit(F$GetJPI("","USERNAME"),"TRIM") .nes. "HTTP_SERVER" Then Goto User_Context
$
$! We are running under the web server. Setup some symbols for later use:
$
$ RSH$_FAILED = %X1801801A							! Status for a fail RSH authorization
$ This_File = F$Env("PROCEDURE")
$ crlf = f$fao("!/")
$ put = "write net_link"
$
$!------------------------------------------------------------------------------
$ if P1 .eqs. "HEAD"								! Is this a HEAD request?
$ then										! Yes, send the Content-type and exit
$   put "<DNETCGI>"								!  Set CGI mode (Content-type or Location hdr only)
$   put "Content-type: text/html", crlf, crlf	 				!  Send back a Content-type header
$   put "</DNETCGI>"
$   exit
$ endif
$!----------------------------------------------------------------------------
$!
$ put "<DNETRECMODE>"								! Set implied carriage control.
$ CGI_SYMBOLS "WWW_" "FORM_"							! Set the DCL symbols from the form
$!
$ put "Content-type: text/html" 						! Write the CGI header
$ put ""									! Write a blank line to signal end of header
$!
$ put "<HTML><HEAD>"
$ put "<TITLE>Set_Pass processing...</TITLE>"
$ put "<BODY bgcolor=#ccccff>"
$ put "<PRE>"									! Disable formatting
$ Source = F$Edit(WWW_Remote_Host,"LOWERCASE") + "(''WWW_Remote_ADDR':''WWW_Remote_Port')"	! Construct a source we can audit
$
$! Cannot output a raw LF after the following command:
$
$ def sys$output net_link							! Show any errors to the user
$ set noon									! Dangerous in scripts but we need to catch and error
$
$! Check if the user aggreed to the UW appropriate use policy for looking for
$! a cookie named "UWAUP" with a value of "agree". If not found, then the user
$! back to the policy.
$
$ If WWW_HTTP_REFERER .nes. WWW_HTTP_REFERER - "activate_account_2" 		! Did we get here from activate_account_2.html?
$  Then Options = "ACTIVATE"							!  Yes, set a options we'll use later
$  If "''WWW_HTTP_COOKIE'" .eqs. "''WWW_HTTP_COOKIE'" - "UWAUP=agree" 		!  Do we have cookie set by activate_account.com?
$  Then Put "</PRE><H3>Your browser has not sent the cookie that indicates you've agreed" ! No, complain
$   Put "to the UW Appropriate Use Policy. You may have cookies disabled on your browser"
$   Put "or you may have not agreed to the policy within the last hour. Your account cannot be activated until"
$   Put "your browser sends this cookie.</H3>"
$   Put "<br><b><a href=""/activate_account.html"">[view policy]</b></a>"
$   Put "</body></html>"							! Close the document
$   exit
$  Endif
$ Endif
$
$! Use RSH to create a process in the context of the user that calls this file
$! to do the work.
$
$ rsh wcs-cluster/user="''Form_FLD_Username'"/Pass="''Form_FLD_Password'" -	! Create a process using supplied user/pwd
  "@''This_File' ""''Form_FLD_password'"" ""''Form_FLD_New'"" ""''Form_FLD_Verified'"" ""''Options'"" ""''www_http_referer'"""
$ If $Status .eq. RSH$_FAILED 
$  Then Put "<hr noshade><H3>The username and/or password you supplied were not correct</H3>"
$  put "<form><input type=reset value=""Back to previous page""onClick=""window.history.back()""></form>"
$ EndIf
$ Put "</PRE></body></html>"							! Close the pre-formated text block and document
$ exit
$
$!==============================================================================
$! The following part of this procedure is executed under the username and
$! password submited by the user. If P4 contains "ACTIVATE", then
$! SYS$SYSTEM:SYSMGR_SERVER is called to activate the account.
$! SYS$MANAGER:SET_PASSWORD.COM is called to change the passwords.
$
$!  P1 - Current Password
$!  P2 - New Password
$!  P3 - Verified Password
$!  P4 - Options. If "ACTIVATE", then SYS$SYSTEM:SYSMGR_SERVER will
$!	be called.
$!  P5 - page that originally called this script
$
$User_Context:
$ If_Option = "If P4 .nes. P4 - "						! Operator to test for options in P4
$ Username := 'F$GETJPI("","USERNAME")'
$ say = "write sys$output"
$ Trigger_File = "SYS$LOGIN:FIRST_LOGIN_''Username'.TRIGGER"			! File that triggers FIRST_LOGIN.COM in sylogin
$ Users_to_Notify = "KARCHER,LOWER"						! Users to e-mail activation message to
$ GetUAI 'Username' /Owner=Owner /ExtAuth=Extauth				! Get the state of the users ExtAuth UAF flag
$
$! If Activate option, ExtAuth flag set and the trigger file exists then
$! activate the user's domain account using SYS$SYSTEM:SYSMGR_SERVER.COM
$
$ If_Option "ACTIVATE" .and. F$Search(Trigger_File) .nes. "" 			! Activate option & trigger file exists?
$  Then On Error Then goto Activate_Error					!  Yes, trap errors during activation
$  If ExtAuth Then @SYS$SYSTEM:SYSMGR_SERVER "" NT_ACTIVATE			!  If NT user call the NT_ACTIVATE function 
$  say "<hr noshade><h3>Network account activation was successful!</h3>"
$  Delete 'F$Search(Trigger_File)'						!  Delete trigger file to signal activation done
$  Pipe say "I have just activated my network account." -			!  Notify the help desk
   | (define/user sys$output NL: ; define/user sys$error NL: -			!  Trash mail prompts
   ; MAIL/Subj="''Owner' has just actived their Domain account" Sys$input: 'users_to_notify')
$ EndIf
$
$! Change the user's password
$
$ On error then goto Password_error						! Setup error handler
$ @sys$manager:Set_Password "''P1'" "''P2'" "''P3'"				! Change the passwords
$ say "</pre><hr noshade><h3>Password change was successful!</h3>"
$ say "<p><b>If you have not already done so, we suggest you have a look at "
$ say " <a href=""/new_user.html"">Information for new users</a></b>"
$ Exit
$! ----------------------------------------------------------------------------
$Activate_Error:
$ Status = $Status
$ say "</pre><hr noshade><H3>There has been an error activating your account. "
$ say "Your password has NOT been changed. " 
$ say "If you need assistance please call the HELP desk at 3-3117.</H3>"
$ say "<form><input type=reset value=""Back to previous page""onClick=""window.history.back()""></form>"
$ Request "%SET_PASS, Error code ''Status' activating account for ''Owner' (''F$mess(status)')"
$ Exit Status .or. %X10000000							! Exit quietly
$
$Password_Error:
$ Status = $Status
$ say "</pre><hr noshade><H3>There has been an error changing your password. "
$ say "Your password has NOT been changed. " 
$ say "If you need assistance please call the HELP desk at 3-3117.</H3>"
$ say "<form><input type=reset value=""Back to previous page""onClick=""window.history.back()""></form>"
$ Request "%SET_PASS, Error code ''Status' setting password for ''Owner' (''F$Mess(Status)')"
$ Exit Status .or. %X10000000							! Exit quietly
